#!/usr/bin/php
<?php
/*
// isdf - dhcp generator
// Author: Carsten Schoene
//
// $LastChangedDate: 2012-09-15 19:44:43 +0200 (Sat, 15 Sep 2012) $
// $Rev: 1827 $
*/

// define our name
define('MYNAME', "isdf");
// open syslog connection
openlog(MYNAME,LOG_PID | LOG_ODELAY,LOG_MAIL);

// check for required extensions
if ( ! extension_loaded("mysql") ) {
        if ( ! dl("mysql") ) {
                syslog(LOG_ERR,"mysql extension not loaded!");
                exit;
        }
}

// load additional files
define('BASE',dirname(__FILE__));
require_once("MDB2.php");
require_once(BASE . "/config.inc.php");
require_once(BASE . "/config-custom.inc.php");
require_once(BASE . "/db.inc.php");
require_once(BASE . "/inet4.class.php");
require_once(BASE . "/inv-dhcp4.class.php");
require_once(BASE . "/dhcpconf.class.php");

// create database connection
$dbh =& MDB2::singleton($config['isdf']['db'], $config['mdb2']['options'] );

// create inv-dhcp4 object
$idhcp4 = new inv_dhcp4();
 
$qrybkvm="SELECT value FROM inv_system_properties WHERE inv_system_id=(SELECT inv_system_id FROM inv_system_properties WHERE datakey='get_system_type_ix' and value='baremetal-kvm') AND datakey='get_system_net_info';";

$dhcpmacs = array();

$res = $dbh->query($qrybkvm);
if (PEAR::isError($res)) {
        syslog(LOG_ERR, "MDB2: " . $res->getMessage());
} else {
        while (( $row = $res->fetchRow(MDB2_FETCHMODE_ASSOC) )) {
		// each result is interface list with values of mac,interface,linkstatus
		$intlist = preg_split('/\s/',$row['value']);
		foreach ( $intlist as $macintlink ) {
			list($mac,$int,$link) = explode(",", trim($macintlink));
			if ($idhcp4->int_is_valid($mac,$int,$link)) {
				// create dhcp entry - push to array
				array_push($dhcpmacs, $mac);
			}
		}
		
		
	}
}

print_r($dhcpmacs);
